#ifndef _PY_TRIPLE_MOD_H
#define _PY_TRIPLE_MOD_H

#define PY_SSIZE_T_CLEAN

#include <Python.h>

#include "triple_obj.h"


PyModuleDef triple_mod = {
    PyModuleDef_HEAD_INIT,
    .m_name = "triple",
    .m_doc = "RDF triple module.",
    .m_size = -1,
};


PyMODINIT_FUNC
PyInit_triple(void)
{
    if (PyType_Ready (&TripleType) < 0) return NULL;

    PyObject *m = PyModule_Create(&triple_mod);
    if (m == NULL) return NULL;

    Py_INCREF(&TripleType);
    if (PyModule_AddObject(m, "Triple", (PyObject *) &TripleType) < 0) {
        Py_DECREF(&TripleType);
        Py_DECREF(m);
        return NULL;
    }

    return m;
}

#endif
