#include "test_term.c"
#include "test_store_mdb.c"
#include "test_graph.c"

int main(int argc, char **argv) {

    // Set env variable to test path.
    putenv ("LSUP_MDB_STORE_PATH=" TMPDIR "/lsup_test_mdb");
    // Clear out database from previous test.
    rm_r (getenv ("LSUP_MDB_STORE_PATH"));

    int result = (
        term_tests() |
        store_mdb_test() |
        graph_tests() |
        0);

    printf("Test result: %lu\n", (size_t)result);

    if (result != 0) {
        printf("Test failed.");
    }
    else {
        printf("ALL TESTS PASSED\n");
    }

    printf("Tests run: %d\n", tests_run);

    return result != 0;
}

